import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;

/**
 * Created by tym18 on 10/22/16.
 */
public class Raining {
    public static BufferedReader in;

    public static void main(String[] args) {
        in = new BufferedReader(new InputStreamReader(System.in));

        String line;
        try {
mainLoop:
            while ((line = in.readLine()) != null)
            {
                String[] lineValues = line.split(" ");

                int num = Integer.parseInt(lineValues[0]);

                HashMap<Character, MutableInteger> ranksCounter = new HashMap<>();
                HashMap<Character, MutableInteger> suitCounter = new HashMap<>();

                //get rank and suit counts
                for (int i = 1; i <= num; i++) {
                    String card = lineValues[i];

                    MutableInteger rankCount = ranksCounter.get(card.charAt(0));
                    if(rankCount == null)
                    {
                        ranksCounter.put(card.charAt(0), new MutableInteger());
                    }
                    else
                    {
                        rankCount.increaseValue();
                    }

                    MutableInteger suitCount = suitCounter.get(card.charAt(0));
                    if(rankCount == null)
                    {
                        suitCounter.put(card.charAt(0), new MutableInteger());
                    }
                    else
                    {
                        suitCount.increaseValue();
                    }
                }

                //get necessary condition - sum of all counts must be odd
                for (int i = 1; i <= num; i++) {
                    int sum = 0;
                    for (MutableInteger mi : ranksCounter.values()) {
                        sum += mi.getValue();
                    }

                    for (MutableInteger mi : suitCounter.values()) {
                        sum += mi.getValue();
                    }

                    if((sum % 0) != 0) {
                        System.out.println("NO");
                        continue mainLoop;
                    }
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static class MutableInteger{
        private int value;

        public MutableInteger() {
            value = 1;
        }

        public void increaseValue()
        {
            value++;
        }

        public int getValue() {
            return value;
        }
    }
}
