import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Samples {
    public static BufferedReader in;
    public int globalIndex = 0;
    public static int[][] samplesArr;

    public static void main(String[] args) {
        in = new BufferedReader(new InputStreamReader(System.in));

        condition[] conditionsArr;

        String line;
        try {
            while ((line = in.readLine()) != null) {
                int samples = Integer.parseInt(line);
                samplesArr = new int[samples][2];

                for (int i = 0; i < samples; i++) {
                    line = in.readLine();
                    String[] tokens = line.split(" ");

                    samplesArr[i][0] = Integer.parseInt(tokens[0]);
                    samplesArr[i][1] = Integer.parseInt(tokens[1]);
                }

                int conditions = Integer.parseInt(in.readLine());
                conditionsArr = new condition[conditions];
                for (int i = 0; i < conditions; i++) {
                    conditionsArr[i] = new condition(in.readLine());
                }

                for (int i = 0; i < samples; i++) {
                    for (int j = 0; j < conditions; j++) {
                        conditionsArr[j].evaluate(i);
                    }
                }

                for (int i = 0; i < conditions; i++) {
                    System.out.println(conditionsArr[i].pass);
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static class condition {
        public int indexBig = 0; //index for start of condiiton in all sampples
        public int indexSmall = 0; //index for the min/max value
        public int sum = 0;
        public double currValue = 0;
        public double prevVal = 0;

        public int pass = 0; //num of values that are OK with this

        public boolean gt = false;
        public char typr = 'v'; // v = average, i = min, a = max
        public int interval = 0;

        public condition(String conditionStr) {
            String[] tokens = conditionStr.split(" ");

            if (tokens[0].equals("gt"))
                gt = true;

            switch (tokens[1]) {
                case "max":
                    typr = 'a';
                    break;
                case "min":
                    currValue = Integer.MAX_VALUE;
                    typr = 'i';
                    break;
            }

            interval = Integer.parseInt(tokens[2]);

        }

        public void evaluate(int currINdex) {
            update(currINdex);

            if (currINdex != 0) {

                if(gt && samplesArr[currINdex][1] > prevVal)
                    pass++;
                else if(!gt && samplesArr[currINdex][1] < prevVal)
                        pass++;
            }
        }

        public void update(int currIndex) {

            if (typr == 'v') //avg
            {
                while (samplesArr[currIndex][0] - samplesArr[indexBig][0] > interval) {
                    sum -= samplesArr[indexBig][1];
                    indexBig++;
                }

                prevVal = currValue;
                if (currIndex - indexBig != 0)
                {
                    sum += samplesArr[currIndex][1];
                    currValue = sum / (currIndex - indexBig + 1);
                }
                else
                {
                    sum = samplesArr[currIndex][1];
                    currValue = sum;
                }

            } else if (typr == 'i')  //min
            {
                while (samplesArr[currIndex][0] - samplesArr[indexBig][0] > interval) {
                    if(indexSmall == indexBig){
                        recalculateuindexSmallMin(currIndex);   //TODO
                    }

                    indexBig++;
                }

                if(samplesArr[currIndex][1] < currValue)
                {
                    prevVal = currValue;
                    currValue = samplesArr[currIndex][1];
                    indexSmall = currIndex;
                }

            } else    //max
            {
                while (samplesArr[currIndex][0] - samplesArr[indexBig][0] > interval) {
                    if(indexSmall == indexBig){
                        recalculateuindexSmallMax(currIndex);   //TODO
                    }

                    indexBig++;
                }

                if(samplesArr[currIndex][1] > currValue)
                {
                    prevVal = currValue;
                    currValue = samplesArr[currIndex][1];
                    indexSmall = currIndex;
                }
            }
        }

        public void evaluate2(int currINdex) {
            if (currINdex != 0) {
               // if (gt &&  samplesArr[currINdex][1] > currValue )
                if (gt &&  currValue > prevVal && currValue == samplesArr[currINdex][1] )
                    pass++;
               // else if (!gt && samplesArr[currINdex][1] < currValue )
                else if (!gt && currValue < prevVal && currValue == samplesArr[currINdex][1])
                    pass++;
            }
            else
            {
                currValue = samplesArr[currINdex][1];
            }
            if (currINdex+1 < samplesArr.length-1)
            update(currINdex);
        }

        public void update2(int currIndex) {
            currIndex++;
            if (typr == 'v') //avg
            {
                while (samplesArr[currIndex][0] - samplesArr[indexBig][0] > interval) {
//                    double remove = samplesArr[indexBig][1]/ (currIndex - indexBig);
//                    currValue -= remove;
                    sum -= samplesArr[indexBig][1];
                    indexBig++;
                }
                sum += samplesArr[currIndex][1];

                if (currIndex - indexBig != 0)
                {
                    prevVal = currValue;
                    currValue = sum / ((currIndex - indexBig)+1);
                }
                else
                {
                    prevVal = currValue;
                    currValue = sum;
                }
            } else if (typr == 'i')  //min
            {
                while (samplesArr[currIndex][0] - samplesArr[indexBig][0] > interval) {
                    if (indexSmall == indexBig) {
                        recalculateuindexSmallMin(currIndex);
                    }
                    indexBig++;
                }

                if (indexSmall >= indexBig) {
                    if (samplesArr[currIndex][1] <= currValue) {
                        prevVal = currValue;
                        currValue = samplesArr[currIndex][1];
                        indexSmall = currIndex;
                    }
                }
            } else    //max
            {
                while (samplesArr[currIndex][0] - samplesArr[indexBig][0] > interval) {
                    if (indexSmall == indexBig) {
                        recalculateuindexSmallMax(currIndex);
                    }
                    indexBig++;
                }

                if (indexSmall >= indexBig) {
                    if (samplesArr[currIndex][1] >= currValue) {
                        prevVal = currValue;
                        currValue = samplesArr[currIndex][1];
                        indexSmall = currIndex;
                    }
                }
            }

        }

        private void recalculateuindexSmallMax(int currIndex) {
            int temp = 0;
            for (int i = indexBig + 1; i < currIndex; i++) {
                if (samplesArr[i][1] > samplesArr[temp][1]) {
                    temp = i;
                }
            }
            indexSmall = temp;
        }

        private void recalculateuindexSmallMin(int currIndex) {
            int temp = 0;
            for (int i = indexBig + 1; i < currIndex; i++) {
                if (samplesArr[i][1] < samplesArr[temp][1]) {
                    temp = i;
                }
            }
            indexSmall = temp;
        }

    }
    /*
10
60 30
120 28
180 35
240 34
300 40
360 31
420 28
480 2
540 42
600 30
4
gt avg 7200
lt min 300
gt max 300
lt min 100
     */
}
